// HAYATO (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"
#include <string.h>

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _offset + _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	unsigned char id[] = "HAYATO       Sys ";
	char fname[11];
	int i,d;

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SetRecordRange(0x01,0x010);
	disk.SelectDisk(0);
	disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
	if (!memcmp(&buff[1],id,sizeof(id)-1))
	{
		printf("Disk AF܂.\n");
		fcut("DRIVER1", 0x04, 0x02, 0x00, 0x01, 0x01, 0x0000, 0x0400);
		fcut("DRIVER2", 0x04, 0x02, 0x00, 0x0b, 0x01, 0x0000, 0x0400);
		fcut("MUS00",   0x05, 0x02, 0x01, 0x01, 0x01, 0x0000, 0x1000);
		fcut("MUS01",   0x06, 0x03, 0x00, 0x01, 0x01, 0x0000, 0x1000);
	}
	return 0;
}

